/*
 * RSP Software
 * 
 * Sample code
 * 
 * Thu Dec 20 22:41:25 2007
 * 
 * http://rspsoftware.bighost.com.br
 * info@rspsoftware.bighost.com.br
 * 
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
namespace encrypt
{
    public partial class Form2 : Form
    {

        private int First = 0;
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            Trace.WriteLine("Form2 init");

            this.Text = axRSPEncrypt1.ControlName().ToString() + " - Sample Project";


            label6.Text = "CPU information : " + axRSPEncrypt1.GetCPUVendor().ToString() + " ,  " + axRSPEncrypt1.GetCPUBrandString().ToString();


            comboBox1.Items.Add("IDLE");
            comboBox1.Items.Add("LOWEST");
            comboBox1.Items.Add("BELOW_NORMAL");
            comboBox1.Items.Add("NORMAL");
            comboBox1.Items.Add("ABOVE_NORMAL");
            comboBox1.Items.Add("HIGHEST");
            comboBox1.Items.Add("TIME_CRITICAL");

            comboBox1.Text = "NORMAL";

        }

        private void button8_Click(object sender, EventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox2.Text = openFileDialog1.FileName;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox3.Text = openFileDialog1.FileName;

        }

        private void button10_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox4.Text = openFileDialog1.FileName;

        }

        private void button3_Click(object sender, EventArgs e)
        {
            label4.Text = "Status: Working";

            label3.Text = "Elapsed: ...";
            this.Refresh();



            switch (comboBox1.Text)
            {

                case "IDLE":

                    axRSPEncrypt1.SetProcessorPriority(1);
                    break;
                case "LOWEST":
                    axRSPEncrypt1.SetProcessorPriority(2);
                    break;
                case "BELOW_NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(3);
                    break;
                case "NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(4);
                    break;
                case "ABOVE_NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(5);
                    break;
                case "HIGHEST":
                    axRSPEncrypt1.SetProcessorPriority(6);
                    break;
                case "TIME_CRITICAL":
                    axRSPEncrypt1.SetProcessorPriority(7);

                    break;
                default:
                    axRSPEncrypt1.SetProcessorPriority(4);
                    break;

            }

            First = System.Environment.TickCount;


            if (checkBox1.CheckState == CheckState.Checked)
            {
                bool enable = true;
                axRSPEncrypt1.set_WaitExecution(ref enable);
            }
            else
            {
                bool enable = false;
                axRSPEncrypt1 .   set_WaitExecution(ref enable);

            }



           //     'The following will encrypt the file using AES or RC4 encryption method
    
    if(checkBox3.CheckState ==CheckState.Checked )
    {
    //    'Use new AES 256 bits encryption mode with crc data verification
        axRSPEncrypt1.NewEncryptFileAES(textBox2.Text, textBox3.Text, textBox1.Text);
    }

    if(checkBox4.CheckState == CheckState.Checked)
    {
       // 'Use new Standard RC4 encryption mode with crc data verification
        axRSPEncrypt1.NewEncryptFileRC4(textBox2.Text, textBox3.Text, textBox1.Text);
    }
               if(checkBox2.CheckState == CheckState.Checked )
               {
       // 'Use new AES 256 bits CTR encryption mode with crc data verification
                   axRSPEncrypt1.NewEncryptFileAES_CTR(textBox2.Text, textBox3.Text, textBox1.Text);
               }

               Trace.WriteLine("Function exit");
        }

        private void button4_Click(object sender, EventArgs e)
        {

            First = System.Environment.TickCount;

            label4.Text = "Status: Working";

            label3.Text = "Elapsed: ...";
            this.Refresh();

            switch (comboBox1.Text)
            {

                case "IDLE":

                    axRSPEncrypt1.SetProcessorPriority(1);
                    break;
                case "LOWEST":
                    axRSPEncrypt1.SetProcessorPriority(2);
                    break;
                case "BELOW_NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(3);
                    break;
                case "NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(4);
                    break;
                case "ABOVE_NORMAL":
                    axRSPEncrypt1.SetProcessorPriority(5);
                    break;
                case "HIGHEST":
                    axRSPEncrypt1.SetProcessorPriority(6);
                    break;
                case "TIME_CRITICAL":
                    axRSPEncrypt1.SetProcessorPriority(7);

                    break;
                default:
                    axRSPEncrypt1.SetProcessorPriority(4);
                    break;

            }

            if (checkBox1.CheckState == CheckState.Checked)
            {
                bool enable = true;
                axRSPEncrypt1.set_WaitExecution(ref enable);
            }
            else
            {
                bool enable = false;
                axRSPEncrypt1.set_WaitExecution(ref enable);

            }



            //     'The following will encrypt the file using AES or RC4 encryption method

            if (checkBox3.CheckState == CheckState.Checked)
            {
                //    'Use new AES 256 bits encryption mode with crc data verification
                axRSPEncrypt1.NewDecryptFileAES(textBox3.Text, textBox4.Text, textBox1.Text);
            }

            if (checkBox4.CheckState == CheckState.Checked)
            {
                // 'Use new Standard RC4 encryption mode with crc data verification
                axRSPEncrypt1.NewDecryptFileRC4(textBox3.Text, textBox4.Text, textBox1.Text);
            }
            if (checkBox2.CheckState == CheckState.Checked)
            {
                // 'Use new AES 256 bits CTR encryption mode with crc data verification
                axRSPEncrypt1.NewDecryptFileAES_CTR(textBox3.Text, textBox4.Text, textBox1.Text);
            }

            Trace.WriteLine("Function exit");






        }

        private void button5_Click(object sender, EventArgs e)
        {
            axRSPEncrypt1.PauseExecution();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            axRSPEncrypt1.ResumeExecution();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            axRSPEncrypt1.CancelExecution();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void checkBox2_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox4.CheckState = CheckState.Unchecked ;
            checkBox3.CheckState = CheckState.Unchecked ;
                checkBox2.CheckState = CheckState.Checked ;
        }

        private void checkBox3_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox4.CheckState = CheckState.Unchecked;
            checkBox2.CheckState = CheckState.Unchecked;
            checkBox3.CheckState = CheckState.Checked;
        }

        private void checkBox4_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox2.CheckState = CheckState.Unchecked;
            checkBox3.CheckState = CheckState.Unchecked;
            checkBox4.CheckState = CheckState.Checked;
        }

        private void axRSPEncrypt1_ErrorCode(object sender, AxRSPEncrypt_a350.__RSPEncrypt_ErrorCodeEvent e)
        {
            listBox1.Items.Add(e.errorNumber.ToString() + " " + e.errorDescription);
            int ret;

            ret = listBox1.Items.Count;
            listBox1.SelectedIndex = ret - 1;

        }

        private void axRSPEncrypt1_Finished(object sender, AxRSPEncrypt_a350.__RSPEncrypt_FinishedEvent e)
        {
            listBox1.Items.Add(e.returnValue .ToString() + " " + e.returnDescription );
            int ret;

            ret = listBox1.Items.Count;
            listBox1.SelectedIndex = ret - 1;

            First = System.Environment.TickCount - First;

            double a = First;

            a = a / 1000;
            label3.Text = "Elapsed: " + a.ToString();
            label4.Text = "Status: Finished";

        }

        private void axRSPEncrypt1_Progress(object sender, AxRSPEncrypt_a350.__RSPEncrypt_ProgressEvent e)
        {
            progressBar1.Value = e.progressValue;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            button9.Text = axRSPEncrypt1.GetCPUSpeed();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axRSPEncrypt1.About();
        }
    }
}
